(** This is the user accessible static methods of the CP runtime system.
  * These are the environment-independent ones. Others are in CP*.cp
  * Note:  the bodies of these procedures are dummies, this module is
  *        compiled with -special.  The real code is in RTS.java or other.
  *
  * Version:	 7 July     1999 (kjg).
  *		20 February 2000 (kjg)  Default target ...
  *		 4 July     2000 (kjg)	Native types ...
  *)

SYSTEM MODULE RTS;

  VAR defaultTarget- : ARRAY 4 OF CHAR;

  TYPE	CharOpen*	= POINTER TO ARRAY OF CHAR;

  TYPE	NativeObject*   = POINTER TO ABSTRACT RECORD END;  
	NativeString*	= POINTER TO RECORD END;
	NativeException*= POINTER TO EXTENSIBLE RECORD END;

  PROCEDURE getStr*(x : NativeException) : CharOpen; 

  PROCEDURE StrToReal*(IN s : ARRAY OF CHAR; OUT r : REAL; OUT ok : BOOLEAN);
  (** Parse array into an ieee double REAL *)

  PROCEDURE StrToInt*(IN s : ARRAY OF CHAR; OUT i : INTEGER; OUT ok : BOOLEAN);
  (** Parse an array into a CP INTEGER *)

  PROCEDURE StrToLong*(IN s : ARRAY OF CHAR; OUT i : LONGINT; OUT ok : BOOLEAN);
  (** Parse an array into a CP LONGINT *)

  PROCEDURE RealToStr*(r : REAL; OUT s : ARRAY OF CHAR);
  (** Decode a CP REAL into an array *)

  PROCEDURE IntToStr*(i : INTEGER; OUT s : ARRAY OF CHAR);
  (** Decode a CP INTEGER into an array *)

  PROCEDURE LongToStr*(i : LONGINT; OUT s : ARRAY OF CHAR);
  (** Decode a CP INTEGER into an array *)

  PROCEDURE realToLongBits*(r : REAL) : LONGINT;
  (** Convert an ieee double into a longint with same bit pattern *)

  PROCEDURE longBitsToReal*(l : LONGINT) : REAL;
  (** Convert an ieee double into a longint with same bit pattern *)

  PROCEDURE hiInt*(l : LONGINT) : INTEGER;
  (** Get hi-significant word of long integer *)

  PROCEDURE loInt*(l : LONGINT) : INTEGER;
  (** Get lo-significant word of long integer *)

  PROCEDURE Throw*(IN s : ARRAY OF CHAR);
  (** Abort execution with an error *)

  PROCEDURE GetMillis*() : LONGINT;
  (** Get time in milliseconds *)

  PROCEDURE GetDateString*(OUT str : ARRAY OF CHAR);
  (** Get a date string in some native format *)

  PROCEDURE ClassMarker*(o : ANYPTR);

END RTS.
